import { IAttributeChangeOptions, IAttributeSetReturn, IAttributes } from '@pilotlab/data';
import { Stack } from '@pilotlab/collections';
import { Signal } from '@pilotlab/signals';
import Message from '../message';
import StateFactory from '../stateFactory';
import IState from './iState';
export interface IStates extends IAttributes {
    create: StateFactory;
    internalCurrentPrincipalIndex: number;
    active: Stack<IState>;
    current: IState;
    previous: IState;
    pathPrevious: string;
    pathLast: string;
    resetCompleted: Signal<any>;
    entered: Signal<IState>;
    exited: Signal<IState>;
    message: Signal<Message>;
    reset(baseStateName?: string, value?: any): this;
    isCurrent(name: string): boolean;
    add(state: IState, index?: number, changeOptions?: IAttributeChangeOptions): IState;
    set(path: string, value?: any, label?: string): IAttributeSetReturn;
    addPrincipal(path: string, value?: any, isSkipOnPrevious?: boolean): IAttributeSetReturn;
    removePrincipal(path: string): IState;
    isPrincipal(path: string): boolean;
    getPrincipalIndex(path: string): number;
    goFirst(value?: any, changeOptions?: IAttributeChangeOptions): IState;
    goNext(value?: any, changeOptions?: IAttributeChangeOptions, isCycle?: boolean): IState;
    goPrevious(value?: any, changeOptions?: IAttributeChangeOptions, isCycle?: boolean): IState;
    goLast(value?: any, changeOptions?: IAttributeChangeOptions): IState;
    internalPush(state: IState, value: any, changeOptions: IAttributeChangeOptions, isEnter?: boolean, isExitPrevious?: boolean, isPopAllActiveStates?: boolean): this;
    internalPushSegment(segment: string, value: any, changeOptions: IAttributeChangeOptions, isEnter: boolean, isExitPrev: boolean, isPopAll: boolean): IState;
    enter(path: string, value?: any, changeOptions?: IAttributeChangeOptions): IState;
    exitCurrent(changeOptions?: IAttributeChangeOptions): this;
    pop(changeOptions?: IAttributeChangeOptions, isExit?: boolean, isEnterPrevious?: boolean): this;
    popAllAbove(state: (IState | string), changeOptions?: IAttributeChangeOptions, isExitEach?: boolean, isEnter?: boolean): this;
    exit(state: (IState | string), changeOptions?: IAttributeChangeOptions): this;
    popAllAboveInclusive(state: (IState | string), changeOptions?: IAttributeChangeOptions, isExitEach?: boolean, isEnterPrev?: boolean): this;
    popAll(isExitEach?: boolean, changeOptions?: IAttributeChangeOptions): this;
    swap(state: (IState | string), value?: any, changeOptions?: IAttributeChangeOptions, isExitCurrent?: boolean): this;
    get(path: string): IState;
    broadcastMessage(message: string, data?: any): IStates;
}
export default IStates;
